//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
// modified by HS 24 June 2010 for VPC (Volume-Price Confirmation/Contradiction)
#property  link      "http://www.futuresandforex.info/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Silver
#property  indicator_color2  Red
#property  indicator_width1  2
//---- indicator parameters
//extern int FastEMA=12;
//extern int SlowEMA=26;
extern int SignalSMA=5;
extern int MA_Period=10;

//---- indicator buffers
double     VPCBuffer[];
double     SignalBuffer[];
//---- calculation buffers
double     VWMABuffer[];
double     SMABuffer[];
//----
int ExtCountedBars=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,MA_Period);
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,VPCBuffer);
   SetIndexBuffer(1,SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("VPC("+MA_Period+"/"+SignalSMA+")");
   SetIndexLabel(0,"VPC");
   SetIndexLabel(1,"Signal");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Volume Price Confirmation/Contradicition                         |
//+------------------------------------------------------------------+
int start()
{
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- VPC counted in the 1-st buffer
   for(int i=0; i<limit; i++)
      VPCBuffer[i]=iCustom(NULL,0,"myVWMA",MA_Period,0,4,0,i)-iCustom(NULL,0,"myVWMA",MA_Period,0,0,0,i);
//---- signal line counted in the 2-nd buffer
   for(i=0; i<limit; i++)
      SignalBuffer[i]=iMAOnArray(VPCBuffer,Bars,SignalSMA,0,MODE_SMA,i);
//---- done
   return(0);

}
//+------------------------------------------------------------------+